package org.apache.commons.lang3.concurrent;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import org.apache.commons.lang3.Validate;
import org.apache.commons.lang3.concurrent.BackgroundInitializer;

public class CallableBackgroundInitializer<T> extends BackgroundInitializer<T> {
  private final Callable<T> callable;
  
  public CallableBackgroundInitializer(Callable<T> call) {
    checkCallable(call);
    this.callable = call;
  }
  
  public CallableBackgroundInitializer(Callable<T> call, ExecutorService exec) {
    super(exec);
    checkCallable(call);
    this.callable = call;
  }
  
  protected T initialize() throws Exception {
    return this.callable.call();
  }
  
  private void checkCallable(Callable<T> callable) {
    Validate.notNull(callable, "callable", new Object[0]);
  }
}
